#include "oled.h"
#include "IIC.h"
#include "oledfont.h"  	 
//OLEDԴ
//Ÿʽ.
//[0]0 1 2 3 ... 127	
//[1]0 1 2 3 ... 127	
//[2]0 1 2 3 ... 127	
//[3]0 1 2 3 ... 127	
//[4]0 1 2 3 ... 127	
//[5]0 1 2 3 ... 127	
//[6]0 1 2 3 ... 127	
//[7]0 1 2 3 ... 127 			

/**********************************************/

#define RES_ON() {GPIO_SetBits(GPIOB, GPIO_Pin_7);}   //
#define RES_OFF() {GPIO_ResetBits(GPIOB, GPIO_Pin_7);}

void RES_Init(void)
{ 
	GPIO_InitTypeDef  GPIO_InitStructure;
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);					  											 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;                 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}

void RES_RESET() //λţϵҪһ͵ƽ
{
  u8 i=100;
  RES_OFF();
	while(i--);
	RES_ON();
}

void OLED_WR_Byte(unsigned dat,unsigned cmd) //ӿں
{
	if(cmd)
			{
       I2C1_Write_Bytes(0x78,0x40,dat);   //Slave address 0X78,SA0=0  //write data
		  }
	else 
		 {
      I2C1_Write_Bytes(0x78,0x00,dat); 		//write command
	   }
}
void OLED_MUl_WR_Byte(uint8_t* buffer, uint8_t buff_size) //ӿں
{  
	I2C1_Mulit_Write_Bytes(0x78,0x40,buff_size,buffer);
}
	
//m^n
u32 oled_pow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}	
//ʼSSD1306					    
void OLED_Init(void)
{ 	
	RES_Init();
  RES_RESET();
  OLED_WR_Byte(0xAE,OLED_CMD);//--display off
	OLED_WR_Byte(0x00,OLED_CMD);//---set low column address
	OLED_WR_Byte(0x10,OLED_CMD);//---set high column address
	OLED_WR_Byte(0x40,OLED_CMD);//--set start line address  
	OLED_WR_Byte(0xB0,OLED_CMD);//--set page address
	OLED_WR_Byte(0x81,OLED_CMD); // contract control
	OLED_WR_Byte(0xFF,OLED_CMD);//--128   
	OLED_WR_Byte(0xA1,OLED_CMD);//set segment remap 
	OLED_WR_Byte(0xA6,OLED_CMD);//--normal / reverse
	OLED_WR_Byte(0xA8,OLED_CMD);//--set multiplex ratio(1 to 64)
	OLED_WR_Byte(0x3F,OLED_CMD);//--1/32 duty
	OLED_WR_Byte(0xC8,OLED_CMD);//Com scan direction
	OLED_WR_Byte(0xD3,OLED_CMD);//-set display offset
	OLED_WR_Byte(0x00,OLED_CMD);//
	
	OLED_WR_Byte(0xD5,OLED_CMD);//set osc division
	OLED_WR_Byte(0x80,OLED_CMD);//
	
	OLED_WR_Byte(0xD8,OLED_CMD);//set area color mode off
	OLED_WR_Byte(0x05,OLED_CMD);//
	
	OLED_WR_Byte(0xD9,OLED_CMD);//Set Pre-Charge Period
	OLED_WR_Byte(0xF1,OLED_CMD);//
	
	OLED_WR_Byte(0xDA,OLED_CMD);//set com pin configuartion
	OLED_WR_Byte(0x12,OLED_CMD);//
	
	OLED_WR_Byte(0xDB,OLED_CMD);//set Vcomh
	OLED_WR_Byte(0x30,OLED_CMD);//
	
	OLED_WR_Byte(0x8D,OLED_CMD);//set charge pump enable
	OLED_WR_Byte(0x14,OLED_CMD);//10 disalbe
	
	OLED_WR_Byte(0xAF,OLED_CMD);//--turn on oled panel
}  

//
	void OLED_Set_Pos(unsigned char x, unsigned char y) 
{ 	
	OLED_WR_Byte(0xb0+y,OLED_CMD);
	OLED_WR_Byte(((x&0xf0)>>4)|0x10,OLED_CMD);
	OLED_WR_Byte((x&0x0f),OLED_CMD); 
}   	  
//OLEDʾ    
void OLED_Display_On(void)
{
	OLED_WR_Byte(0X8D,OLED_CMD);  //SET DCDC
	OLED_WR_Byte(0X14,OLED_CMD);  //DCDC ON
	OLED_WR_Byte(0XAF,OLED_CMD);  //DISPLAY ON
}
//رOLEDʾ     
void OLED_Display_Off(void)
{
	OLED_WR_Byte(0X8D,OLED_CMD);  //SET DCDC
	OLED_WR_Byte(0X10,OLED_CMD);  //DCDC OFF
	OLED_WR_Byte(0XAE,OLED_CMD);  //DISPLAY OFF
}		   			 
//,,ĻǺɫ!ûһ!!!	  
void OLED_Clear(void)  
{  
	u8 i,n;		    
	for(i=0;i<8;i++)  
	{  
		OLED_WR_Byte (0xb0+i,OLED_CMD);    //ҳַ0~7
		OLED_WR_Byte (0x00,OLED_CMD);      //ʾλáе͵ַ
		OLED_WR_Byte (0x10,OLED_CMD);      //ʾλáиߵַ   
		for(n=0;n<128;n++)OLED_WR_Byte(0,OLED_DATA); 
	} //ʾ
}
void OLED_On(void)  
{  
	u8 i,n;		    
	for(i=0;i<8;i++)  
	{  
		OLED_WR_Byte (0xb0+i,OLED_CMD);    //ҳַ0~7
		OLED_WR_Byte (0x00,OLED_CMD);      //ʾλáе͵ַ
		OLED_WR_Byte (0x10,OLED_CMD);      //ʾλáиߵַ   
		for(n=0;n<128;n++)OLED_WR_Byte(1,OLED_DATA); 
	} //ʾ
}

void OLED_ShowChar(u8 x,u8 y,u8 chr,u8 Char_Size)//Char_Size:32/16/8
{      	
	unsigned char c=0,i=0;	
		
		if(x>Max_Column-1){x=0;y=y+2;}
		if(Char_Size==16)
			{
			 c=chr-' ';//õƫƺֵ	
			 OLED_Set_Pos(x,y);	
			 for(i=0;i<8;i++)
			    OLED_WR_Byte(F8X16[c*16+i],OLED_DATA);
				
       OLED_Set_Pos(x,y+1);
			 for(i=0;i<8;i++)
			    OLED_WR_Byte(F8X16[c*16+i+8],OLED_DATA);
			}
		if(Char_Size==32)
			{
			 c=chr-'0';//õƫƺֵ	
			 OLED_Set_Pos(x,y);	
			 for(i=0;i<16;i++)
			    OLED_WR_Byte(DF16X32[c*4][i],OLED_DATA);
			 OLED_Set_Pos(x,y+1);
			 for(i=0;i<16;i++)
			    OLED_WR_Byte(DF16X32[c*4+1][i],OLED_DATA);
       OLED_Set_Pos(x,y+2);
			 for(i=0;i<16;i++)
			    OLED_WR_Byte(DF16X32[c*4+2][i],OLED_DATA);
			 OLED_Set_Pos(x,y+3);
			 for(i=0;i<16;i++)
			    OLED_WR_Byte(DF16X32[c*4+3][i],OLED_DATA);
			}
	  if(Char_Size==8) 
		  {	
				c=chr-' ';//õƫƺֵ	
				OLED_Set_Pos(x,y);
				for(i=0;i<6;i++)
				    OLED_WR_Byte(F6x8[c][i],OLED_DATA);				
			}
}

void OLED_Show_Negative_Char(u8 x,u8 y,u8 chr,u8 Char_Size) //Char_Size:32/16/8
{      	
	{      	
	unsigned char c=0,i=0;	
		
		if(x>Max_Column-1){x=0;y=y+2;}
		if(Char_Size==16)
			{
			 c=chr-' ';//õƫƺֵ	
			 OLED_Set_Pos(x,y);	
			 for(i=0;i<8;i++)
			    OLED_WR_Byte(~F8X16[c*16+i],OLED_DATA);
				
       OLED_Set_Pos(x,y+1);
			 for(i=0;i<8;i++)
			    OLED_WR_Byte(~F8X16[c*16+i+8],OLED_DATA);
			}
		if(Char_Size==32)
			{
			 c=chr-'0';//õƫƺֵ	
			 OLED_Set_Pos(x,y);	
			 for(i=0;i<16;i++)
			    OLED_WR_Byte(~DF16X32[c*4][i],OLED_DATA);
			 OLED_Set_Pos(x,y+1);
			 for(i=0;i<16;i++)
			    OLED_WR_Byte(~DF16X32[c*4+1][i],OLED_DATA);
       OLED_Set_Pos(x,y+2);
			 for(i=0;i<16;i++)
			    OLED_WR_Byte(~DF16X32[c*4+2][i],OLED_DATA);
			 OLED_Set_Pos(x,y+3);
			 for(i=0;i<16;i++)
			    OLED_WR_Byte(~DF16X32[c*4+3][i],OLED_DATA);
			}
	  if(Char_Size==8) 
		  {	
				c=chr-' ';//õƫƺֵ	
				OLED_Set_Pos(x,y);
				for(i=0;i<6;i++)
				    OLED_WR_Byte(~F6x8[c][i],OLED_DATA);				
			}
}
}
//ʾһַŴ
void OLED_ShowString(u8 x,u8 y,u8 *chr,u8 Char_Size)
{
	unsigned char j=0;
	if(Char_Size==32)
	{
		while (chr[j]!='\0')
	   {		
			 OLED_ShowChar(x,y,chr[j],Char_Size);
		   x+=16;
		   if(x>120)
         {x=0;y+=2;}
			 j++;
	   }
  }
	else
	{
		while (chr[j]!='\0')
	   {		
			 OLED_ShowChar(x,y,chr[j],Char_Size);
		   x+=8;
		   if(x>120)
         {x=0;y+=2;}
			 j++;
	   }
  }
}
//ʾһַŴ
void OLED_Show_Negative_String(u8 x,u8 y,u8 *chr,u8 Char_Size)
{
	unsigned char j=0;
	if(Char_Size==32)
	{
		while (chr[j]!='\0')
	   {		
			 OLED_Show_Negative_Char(x,y,chr[j],Char_Size);
		   x+=16;
		   if(x>120)
         {x=0;y+=2;}
			 j++;
	   }
  }
	else
	{
		while (chr[j]!='\0')
	   {		
			 OLED_Show_Negative_Char(x,y,chr[j],Char_Size);
		   x+=8;
		   if(x>120)
         {x=0;y+=2;}
			 j++;
	   }
  }
}

//ʾ x:;y:;no

void OLED_ShowCHinese(u8 x,u8 y,u8 no)
{      			    
	u8 t,adder=0;
	OLED_Set_Pos(x,y);	
    for(t=0;t<16;t++)
		{
				OLED_WR_Byte(Hzk[2*no][t],OLED_DATA);
				adder+=1;
     }	
		OLED_Set_Pos(x,y+1);	
    for(t=0;t<16;t++)
			{	
				OLED_WR_Byte(Hzk[2*no+1][t],OLED_DATA);
				adder+=1;
      }					
}

void OLED_Show16x16Icon(u8 x,u8 y,u8 num) //ɳ©ͼ
{      			    
	u8 t;
	OLED_Set_Pos(x,y);	
    for(t=0;t<16;t++)
		{
				OLED_WR_Byte(TimeICON[2*num][t],OLED_DATA);
     }	
		OLED_Set_Pos(x,y+1);	
    for(t=0;t<16;t++)
			{	
				OLED_WR_Byte(TimeICON[2*num+1][t],OLED_DATA);
      }					
}


void OLED_Show16x30ICON(u8 x,u8 y,u8 num) //chr:0 1 2 3 С16*30
{      	
	unsigned char i=0;	
		
		if(x>Max_Column-1){x=0;y=y+2;}	
			 OLED_Set_Pos(x,y);	
			 for(i=0;i<30;i++)
			    OLED_WR_Byte(BatteryICON[num*60+i],OLED_DATA);
			 OLED_Set_Pos(x,y+1);
			 for(i=0;i<30;i++)
			    OLED_WR_Byte(BatteryICON[num*60+30+i],OLED_DATA);	
}


void OLED_Show32x32ICON(s8 x,u8 y,u8 num) //x-32127 ʾӱ߽гЧ
{      	
	unsigned char i=0;	
		if(x<0)
		 {
			x=0-x;
			 OLED_Set_Pos(0,y);	
			 for(i=x;i<32;i++)
			    OLED_WR_Byte(MenuICON[num*128+i],OLED_DATA);
			 OLED_Set_Pos(0,y+1);
			 for(i=x;i<32;i++)
			    OLED_WR_Byte(MenuICON[num*128+32+i],OLED_DATA);
		   OLED_Set_Pos(0,y+2);
			 for(i=x;i<32;i++)
			    OLED_WR_Byte(MenuICON[num*128+64+i],OLED_DATA);
			 OLED_Set_Pos(0,y+3);
			 for(i=x;i<32;i++)
			    OLED_WR_Byte(MenuICON[num*128+96+i],OLED_DATA);		
	   } 
	 else if(x>96)
		{
			 OLED_Set_Pos(x,y);	
			 for(i=x;i<128-x;i++)
			    OLED_WR_Byte(MenuICON[num*128+i],OLED_DATA);
			 OLED_Set_Pos(x,y+1);
			 for(i=x;i<128-x;i++)
			    OLED_WR_Byte(MenuICON[num*128+32+i],OLED_DATA);
		   OLED_Set_Pos(x,y+2);
			 for(i=x;i<128-x;i++)
			    OLED_WR_Byte(MenuICON[num*128+64+i],OLED_DATA);
			 OLED_Set_Pos(x,y+3);
			 for(i=x;i<128-x;i++)
			    OLED_WR_Byte(MenuICON[num*128+96+i],OLED_DATA);		
	 }
	else
  {
			 OLED_Set_Pos(x,y);	
			 for(i=0;i<32;i++)
			    OLED_WR_Byte(MenuICON[num*128+i],OLED_DATA);
			 OLED_Set_Pos(x,y+1);
			 for(i=0;i<32;i++)
			    OLED_WR_Byte(MenuICON[num*128+32+i],OLED_DATA);
		   OLED_Set_Pos(x,y+2);
			 for(i=0;i<32;i++)
			    OLED_WR_Byte(MenuICON[num*128+64+i],OLED_DATA);
			 OLED_Set_Pos(x,y+3);
			 for(i=0;i<32;i++)
			    OLED_WR_Byte(MenuICON[num*128+96+i],OLED_DATA);		 
	}
}

void OLED_Clear32x32ICON(s8 x,u8 y) //10λ
{	
	unsigned char i=0;	
	if(x<0)
	{
	  x=x+32;
	      OLED_Set_Pos(0,y);	
			 for(i=0;i<x;i++)
			    OLED_WR_Byte(0x00,OLED_DATA);
			 OLED_Set_Pos(0,y+1);
			 for(i=0;i<x;i++)
			    OLED_WR_Byte(0x00,OLED_DATA);
		   OLED_Set_Pos(0,y+2);
			 for(i=0;i<x;i++)
			    OLED_WR_Byte(0x00,OLED_DATA);
			 OLED_Set_Pos(0,y+3);
			 for(i=0;i<x;i++)
			    OLED_WR_Byte(0x00,OLED_DATA);		
	}
  else if(x<=96)
	{
		
      OLED_Set_Pos(x+12,y);	
			 for(i=0;i<20;i++)
			    OLED_WR_Byte(0x00,OLED_DATA);
			 OLED_Set_Pos(x+12,y+1);
			 for(i=0;i<20;i++)
			    OLED_WR_Byte(0x00,OLED_DATA);
		   OLED_Set_Pos(x+12,y+2);
			 for(i=0;i<20;i++)
			    OLED_WR_Byte(0x00,OLED_DATA);
			 OLED_Set_Pos(x+12,y+3);
			 for(i=0;i<20;i++)
			    OLED_WR_Byte(0x00,OLED_DATA);		
	}
}





















