
#include "TIMER.h"
#include "TIM_PWM.h"
extern ClockTypeDef TotalClock,CurrentClock,Clock[10];
extern u16 BEEP_Time;
extern u8  PageState;
extern u16  RateTimes;
extern u8  BEEP_STATE;
extern u8 CountdownTime;
void TIM_INIT_Config(void)                                     //TIM3жϳʼ
{
  TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;               //TIM_TimeBaseInitTypeDefṹ
  NVIC_InitTypeDef NVIC_InitStructure;                         //NVIC_InitTypeDef ṹ
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);         //ʹTIM3ʱ

// ʱ
  TIM_TimeBaseStructure.TIM_Period = 9999;                     //10msж//Զؼ=1199+1=1200
  TIM_TimeBaseStructure.TIM_Prescaler = 48-1;                   //ʱ48Ƶ1MHz 1usһμʱʱƵ=TIM_Prescaler+1=4
  TIM_TimeBaseStructure.TIM_ClockDivision = 1;                 //벶ʱ˲õĲ,һ
  TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //ϼ
  TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);              //ָĲʼ

// TIM3 жǶ

  NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;              //ѡTIM3IRQͨ
  NVIC_InitStructure.NVIC_IRQChannelPriority = 0;              //IRQͨȼ=0
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //ʹIRQͨ
  NVIC_Init(&NVIC_InitStructure);                              //Բ

  TIM_ClearFlag(TIM3, TIM_FLAG_Update);                        //־λһжϺж

  TIM_ARRPreloadConfig(TIM3, DISABLE);                         //ֹARRԤװػ  
  TIM_ITConfig(TIM3,TIM_IT_Update, ENABLE);                    //ʹTIM3ж
  TIM_Cmd(TIM3, ENABLE);                                       //ʹTIM3 ж
}


void DisTIM3(void)
{
  TIM_Cmd(TIM3, DISABLE);
}

void UpdateClock(ClockTypeDef *P)
{
  P->Clock10xMS++;
	if(P->Clock10xMS>99)
	{
		P->Clock10xMS=0;
	  P->ClockS++;
		if(P->ClockS>59)
		{
			P->ClockS=0;
		  P->ClockM++;
			if(P->ClockM>59)
			{
			 	P->ClockM=0;
		    P->ClockM=0;
			}
		}	
	}
}

void ClearClock(ClockTypeDef *P)
{
	P->Clock10xMS=0;
	P->ClockS=0;
	P->ClockM=0;
}

void TransClock(ClockTypeDef *SourceP,ClockTypeDef *TargetP)
{
   TargetP->ClockM=SourceP->ClockM;
   TargetP->ClockS=SourceP->ClockS;
	 TargetP->Clock10xMS=SourceP->Clock10xMS;
}

void TIM3_IRQHandler(void)                                                 // TIM3жϺ
{
   if (TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET)  //TIM3жϷ
		{	  
			
		 TIM_ClearITPendingBit(TIM3, TIM_IT_Update);  //TIMxжϱ־ 
			
	   UpdateClock(&TotalClock);
		 UpdateClock(&CurrentClock);
			
		 if(BEEP_STATE==1)
	   {
		   BEEP_Time++;
	    }
		 
		 if(PageState==24)
	   {
		   RateTimes++;
		 }
		 
		}                                                                   
}

