#include "stm32f0xx.h"
#include "type.h"
#include <stdio.h>

typedef struct  
{										    
	u8 ClockM;  //
	u8 ClockS; 	//
	u8 Clock10xMS; //10
}ClockTypeDef;

typedef struct  
{					
  u8 Times; //
	u8 H; //ʱ
	u8 M; //
	u8 S; //
}NoteHeadTypeDef;

void TIM_INIT_Config(void);
void DisTIM3(void);
void UpdateClock(ClockTypeDef *P);
void ClearClock(ClockTypeDef *P);
void TransClock(ClockTypeDef *SourceP,ClockTypeDef *TargetP);