#include "TIM_PWM.h"

#define  PRESCALER_VALUE 48  //48Ƶ (SystemCoreClock/PRESCALER_VALUE)=Ƶ1MHz 


/*Ƶ
  1-200HzС
  200-300
  400
  500
  600
  700
  800
  2730Hzʺεһ
  3000ݶ,
*/

void TIM_PWM_GPIO_Config(void)                                     //TIM3жϳʼ
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);

    GPIO_PinAFConfig(GPIOB, GPIO_PinSource10, GPIO_AF_2);       //PB10 ɵڶ_

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
}

void TIM_PWM_Config(uint32_t Freq,uint16_t Dutycycle)          //Ƶʺռձ TIM_PWM_Config(1000,50)Ƶ1000 ռձ50
{
  TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;               //TIM_TimeBaseInitTypeDefṹ
  TIM_OCInitTypeDef TIM_OCInitStructure; 
  uint16_t TimerPeriod,Channel3Pulse;
  
  TimerPeriod = ((SystemCoreClock/PRESCALER_VALUE) / Freq ) - 1;                 //999  //ԤֵTIM1_Period = (timeʱƵ / pwmƵ) - 1  
  Channel3Pulse = (uint16_t) (((uint32_t) Dutycycle * (TimerPeriod - 1)) / 100); //CCR4תֵ ռձΪ50%ʱΪ499*/
	
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);         //ʹTIM2ʱ

   // ʱ
  TIM_TimeBaseStructure.TIM_Prescaler = PRESCALER_VALUE-1;   // ԤƵ
  TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; /* Time ʱΪؼģʽ*/
  TIM_TimeBaseStructure.TIM_Period = TimerPeriod;
  TIM_TimeBaseStructure.TIM_ClockDivision = 0;
  TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
  TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);

   //ͨ3 PWMģʽ
  TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
  TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  //TIM_OCInitStructure.TIM_OutputNState = TIM_OutputNState_Enable;
  TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
  //TIM_OCInitStructure.TIM_OCNPolarity = TIM_OCNPolarity_High;
 // TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Set;
 // TIM_OCInitStructure.TIM_OCNIdleState = TIM_OCIdleState_Reset;

  TIM_OCInitStructure.TIM_Pulse = Channel3Pulse;//ʹƵ3
  TIM_OC3Init(TIM2, &TIM_OCInitStructure);
	
  //TIM_OCInitStructure.TIM_Pulse = Channel4Pulse;//ʹƵ4
  //TIM_OC4Init(TIM2, &TIM_OCInitStructure);
	
  TIM_OC3PreloadConfig(TIM2, TIM_OCPreload_Enable);       
  TIM_ARRPreloadConfig(TIM2, ENABLE);                          //ʹARRԤװػ  
  TIM_Cmd(TIM2, ENABLE);                                       //ʹTIM2 ж

}

void DisPWM(void)
{
  TIM_Cmd(TIM2, DISABLE);
}





