#include "HALL.h"

#define HALL_NC        0   //δ
#define HALL_PRESS     1   //ְ
#define HALL_KEEP      2   //ȶ
#define HALL_RELEASE   3   //ͷ

#define HALL_SW  GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_1)  //ֹͣ

u8 HALLState; //ɨ¼ֵ

void HALL_Init(void)
{ 
	GPIO_InitTypeDef   GPIO_InitStructure;
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE );	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN; 
	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}

/*
void HALL_Init(void)
{ 
	GPIO_InitTypeDef  GPIO_InitStructure;
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);					  											 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;                 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}
*/
u8 ScanHALL(void)
{ 
  switch (HALLState)//ϴɨжϵ״̬
  { 
		case HALL_NC: //ް ʱΪ0
			   if(HALL_SW==0 )
					  HALLState=HALL_PRESS;
				 return 0;
		break;	
		case HALL_PRESS:
			   if(HALL_SW==0)
				 {
					  HALLState=HALL_KEEP;
						return 1;
				 }
			   else
				 {
				   HALLState=HALL_NC;
					 return 0;
				 }
		break;		
		case HALL_KEEP:	
			if(HALL_SW==0)
				{
					 HALLState=HALL_KEEP;//
					 return 11;
			    }
			if(HALL_SW)
			{
					 HALLState=HALL_NC;
					 return 0;
			}
		break;
	}
}



