#include "buttom.h"

#define State_NC        0   //δ
#define State_PRESS     1   //ְ
#define State_KEEP      2   //ȶ
#define State_RELEASE   3   //ͷ

#define KEY1  GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_3)  //ֹͣ
#define KEY2  GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_4)  //ƴΣλ

u8 KeyState; //ɨ¼ֵ

void KEY_Init(void)
{ 
	GPIO_InitTypeDef   GPIO_InitStructure;
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE );	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3/GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN; 
	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}

u8 ScanKey(void)
{ 
  switch (KeyState)//ϴɨжϵ״̬
  { 
		case State_NC: //ް ʱΪ0
			   if(KEY1==0 || KEY2==0 )
					  KeyState=State_PRESS;
				 return 0;
		break;	
		case State_PRESS:
			   if(KEY1==0)
				 {
					  KeyState=State_KEEP;
						return 1;
				 }
				 if(KEY2==0)
				 {
					  KeyState=State_KEEP;
						return 2;
				 }
				 else
				 {
				   KeyState=State_NC;
					 return 0;
				 }
		break;		
		case State_KEEP:	
			if(KEY1==0)
				{
					 KeyState=State_KEEP;//
					 return 11;
			  }
		  if(KEY2==0)
				{
					 KeyState=State_KEEP;
					 return 22;
			  }
			if(KEY1 && KEY2)
			{
					 KeyState=State_NC;
					 return 0;
			}
		break;
		
	}
}

void EXIT_KEY_Init(void) //ðťΪⲿж
{
  NVIC_InitTypeDef   NVIC_InitStructure;
	EXTI_InitTypeDef EXTI_InitStruct;
	
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);
	
	NVIC_InitStructure.NVIC_IRQChannel = EXTI2_3_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	EXTI_InitStruct.EXTI_Line = EXTI_Line3;
	EXTI_InitStruct.EXTI_Mode = EXTI_Mode_Interrupt;
	EXTI_InitStruct.EXTI_Trigger = EXTI_Trigger_Falling;//ж
	EXTI_InitStruct.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStruct); 
	
  SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOB, EXTI_PinSource3);
}


