#include "ADC.h"

void ADC_init(void)
{		
	GPIO_InitTypeDef  GPIO_InitStructure;
	ADC_InitTypeDef ADC_InitStructure;	
	
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;// PA1
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	

	ADC_InitStructure.ADC_Resolution  = ADC_Resolution_12b;
	ADC_InitStructure.ADC_ContinuousConvMode  = DISABLE; //Ƿ
	ADC_InitStructure.ADC_ExternalTrigConvEdge  = ADC_ExternalTrigConvEdge_None;
	ADC_InitStructure.ADC_DataAlign  = ADC_DataAlign_Right;
	ADC_InitStructure.ADC_ScanDirection = ADC_ScanDirection_Upward;	//ɨ
	ADC_Init(ADC1, &ADC_InitStructure);
		
	ADC_GetCalibrationFactor(ADC1);
	ADC_Cmd(ADC1, ENABLE);	
}

void Dis_ADC(void)
{
	
 ADC_Cmd(ADC1, DISABLE);
}
uint32_t ADC_Read()
{
  uint32_t  result=0; 

	ADC_ChannelConfig(ADC1, ADC_Channel_1, ADC_SampleTime_239_5Cycles);
	 
	while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_ADRDY)); //ȴ	
	ADC_StartOfConversion(ADC1);//
  while(ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC) == RESET);   
  result = (uint32_t) ADC_GetConversionValue(ADC1);
	return result;
}
