#include "stm32f0xx.h"
#include "type.h"
#include <stdio.h>

typedef enum {I2C_FAIL=0, I2C_OK=!I2C_FAIL} I2C_Status;

#define I2C_TIMEOUT         (uint32_t)0x30E32E44

void I2C1_init(void);
//I2C_Status I2C1_Read_NBytes(uint8_t driver_Addr, uint8_t start_Addr, uint8_t number_Bytes, uint8_t *read_Buffer);
//I2C_Status I2C1_Write_NBytes(uint8_t driver_Addr, uint8_t start_Addr, uint8_t number_Bytes, uint8_t *write_Buffer);
void I2C1_Write_Bytes(uint8_t driver_Addr,uint8_t REG_Address,uint8_t REG_data);
void I2C1_Read_Bytes(uint8_t driver_Addr,uint8_t REG_Address,uint8_t *read_Buffer);
void I2C1_Mulit_Read_Bytes(uint8_t driver_Addr,uint8_t REG_Address,uint8_t number_Bytes,uint8_t *read_Buffer);
void I2C1_Mulit_Write_Bytes(uint8_t driver_Addr,uint8_t REG_Address,uint8_t number_Bytes,uint8_t *REG_data);