
#include "USART1.h"
#define UART_TX_LEN 64 
extern char USART1_Tbuf[UART_TX_LEN];   //ڻ
extern char USART1_Rbuf[50];   //ջ,USART_REC_LENֽ.
extern u8  USART1_RX_Num;      //	
extern u8  USART1_RX_Sta;      //־ ֪ͨѭ

static void DMA_USART1TX_config()
{
  DMA_InitTypeDef DMA_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE); //DMAʱ
	
	//NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel2_3_IRQn;
  //NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  //NVIC_InitStructure.NVIC_IRQChannelPriority = 2;
  //NVIC_Init(&NVIC_InitStructure);
	
  DMA_DeInit(DMA1_Channel2);//DMA1ͨ2
  DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)(&USART1->TDR);//ַ
  DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)USART1_Tbuf;//ڴַ
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;//dma䷽ڴ浽
  DMA_InitStructure.DMA_BufferSize = UART_TX_LEN;//DMAڴʱĳ
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;//DMAģʽ
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;//DMAڴģʽ
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;//ֳ
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//ڴֳ
  DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;//DMAĴģʽ
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;//DMAȼ
  DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMA2memoryеı
  DMA_Init(DMA1_Channel2,&DMA_InitStructure);
	
	//DMA_ITConfig(DMA1_Channel2,DMA_IT_TC,ENABLE);// ʹDMAж
	DMA_Cmd(DMA1_Channel2,ENABLE);//ʹͨ2
}

void USART1_INIT(void)
{
		GPIO_InitTypeDef  GPIO_InitStructure;
		USART_InitTypeDef USART_InitStructure;
		NVIC_InitTypeDef 	NVIC_InitStructure;
	
		NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPriority = 2;
		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
		NVIC_Init(&NVIC_InitStructure);
	
		RCC_AHBPeriphClockCmd( RCC_AHBPeriph_GPIOA, ENABLE);
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE );						
		GPIO_PinAFConfig(GPIOA,GPIO_PinSource9,GPIO_AF_1);
		GPIO_PinAFConfig(GPIOA,GPIO_PinSource10,GPIO_AF_1);     											 
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9|GPIO_Pin_10;                 
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF; 
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_Init(GPIOA, &GPIO_InitStructure); 
  
    DMA_USART1TX_config();
	
    USART_InitStructure.USART_BaudRate = 115200;//
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No ;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; 
	
		USART_Init(USART1, &USART_InitStructure);
		USART_ClearFlag(USART1,USART_FLAG_TC);
		
		USART_DMACmd(USART1,USART_DMAReq_Tx,ENABLE);	

		USART_ITConfig(USART1,USART_IT_RXNE,ENABLE);
		USART_Cmd(USART1, ENABLE);
}

/**********************************************/	
void printfend(void)
{
	 USART_SendData(USART1,0xFF);
	 while(USART_GetFlagStatus(USART1,USART_FLAG_TC)==RESET);
	 USART_SendData(USART1,0xFF);
	 while(USART_GetFlagStatus(USART1,USART_FLAG_TC)==RESET);
	 USART_SendData(USART1,0xFF);
	 while(USART_GetFlagStatus(USART1,USART_FLAG_TC)==RESET);
}
/**********************************************/

void HMISend(u8 StrLen)
{

  DMA_SetCurrDataCounter(DMA1_Channel2,StrLen); // Ҫ͵ĳ
  DMA_Cmd(DMA1_Channel2,ENABLE); // ٴDMAͨ  
	
	while (DMA_GetFlagStatus(DMA1_FLAG_TC2)==RESET);//ȴ	
	DMA_ClearITPendingBit(DMA1_IT_TC2);    //DMAжϱ־λ   
  DMA_Cmd(DMA1_Channel2,DISABLE); // صDMAͨ	
	
}


/**********************************************/
void DMA1_Channel2_3_IRQHandler(void) 

{          
  if(DMA_GetITStatus(DMA1_IT_TC2) != RESET)  //жDMAж                     
     DMA_ClearITPendingBit(DMA1_IT_TC2);    //DMAжϱ־λ   
  DMA_Cmd(DMA1_Channel2,DISABLE); // صDMAͨ	
}


/**********************************************/
void USART1_IRQHandler(void)
{	
	u8 res;
	if(USART_GetFlagStatus(USART1,USART_FLAG_RXNE)==SET)//յ
	{	 
		res=USART_ReceiveData(USART1); 
		
		USART1_Rbuf[USART1_RX_Num]=res;
    if(USART1_Rbuf[USART1_RX_Num]==0XFF && USART1_RX_Num>=4)//յ
	    {
	      if(USART1_Rbuf[USART1_RX_Num-1]==0XFF && USART1_Rbuf[USART1_RX_Num-2]==0XFF)
			  {
				 USART1_RX_Num=0;
         USART1_RX_Sta=1;//״̬	
			  }
      }
		USART1_RX_Num++;

	 }
} 














